#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

bool isSq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return true;
    return false;
}

long long get_sq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return i;
}

int main()
{
    long long k;
    cin >> k;
    if (k >= 0 && isSq(k))
    {
        cout << get_sq(k);
        return 0;
    }
    if (k >= 0)
    {

        long long ans = 1e18;
        for (long long i = 1; i * i <= k; i++)
        {
            if (k % i == 0 && (i + (k / i)) % 2 == 0)
            {
                ans = min((i + (k / i)) / 2, ans);
            }
        }
        if (ans == 1e18)
            cout << "none";
        else
            cout << ans;
    }

    return 0;
}
