#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

bool isSq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return true;
    return false;
}

long long get_sq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return i;
}

int main()
{
    long long k;
    cin >> k;
    if (k >= 0 && isSq(k))
    {
        cout << get_sq(k);
        return 0;
    }
    long long ak = k;
    if (ak < 0)
        ak = -ak;
    long long ans = 1e18;
    for (long long i = 1; i * i <= ak; i++)
    {
        if (ak % i == 0 && (i + (ak / i)) % 2 == 0)
        {
            long long new_ans;
            if (k >= 0)
                new_ans = (i + (ak / i)) / 2;
            else
                new_ans = ((ak / i) - i) / 2;
            ans = min(new_ans, ans);
        }
    }
    if (ans == 1e18)
        cout << "none";
    else
        cout << ans;

    return 0;
}
