#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

const int MOD = 1e9 + 7;

int main()
{
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, int> > > dp(n + 1, vector<pair<int, int> > (n + 1));
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    dp[k][k] = {1, 1};
    for (int s = 1; s <= n; s++)
    {
        for (int lst = 1; lst <= n; lst++)
        {
            for (int x = 1; x <= n; x++)
            {
                if (s - x < lst)
                    break;
                if (x < lst)
                {
                    dp[s][x].first = (dp[s][x].first + dp[s - x][lst].second) % MOD;
                }
                else if (x > lst)
                {
                    dp[s][x].second = (dp[s][x].second + dp[s - x][lst].first) % MOD;
                }
            }
        }
    }

    int ans = 0;
    for (int lst = 1; lst <= n; lst++)
        ans = (ans * 1LL + 1LL * dp[n][lst].first + dp[n][lst].second) % MOD;
    cout << ans;



    return 0;
}
