#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

#define int long long

const int MOD = 1e9 + 7;

signed main()
{
    int n, k;
    cin >> n >> k;
    vector<vector<pair<int, int> > > dp(n + 1, vector<pair<int, int> > (n + 1));
    vector<vector<pair<int, int> > > sum_dp(n + 1, vector<pair<int, int> > (n + 1));
    if (n == k)
    {
        cout << 1;
        return 0;
    }
    dp[k][k] = {1, 1};

    sum_dp[k][0] = dp[k][0];
    for (int i = 0; i < n; i++)
    {
        sum_dp[k][i + 1] = {(sum_dp[k][i].first + dp[k][i + 1].first) % MOD, (sum_dp[k][i].second + dp[k][i + 1].second) % MOD};
    }

    for (int s = 1; s <= n; s++)
    {
        for (int x = 1; x <= n; x++)
        {
            if (s - x < 0)
                break;
            /*
            for (int lst = 1; lst <= n; lst++)
            {
                if (s - x < lst)
                    break;
                if (x < lst)
                {
                    dp[s][x].first = (dp[s][x].first + dp[s - x][lst].second) % MOD;
                }
                else if (x > lst)
                {
                    dp[s][x].second = (dp[s][x].second + dp[s - x][lst].first) % MOD;
                }
            }
            */

            dp[s][x].second = (1LL * dp[s][x].second + sum_dp[s - x][x - 1].first) % MOD;
            dp[s][x].first = ((1LL * dp[s][x].first + 1LL * sum_dp[s - x][n].second - sum_dp[s - x][x].second) % MOD + MOD) % MOD;
        }
        sum_dp[s][0] = dp[s][0];
        for (int i = 0; i < n; i++)
        {
            if (i + 1 > s)
            {
                sum_dp[s][i + 1] = sum_dp[s][i];
            }
            else
                sum_dp[s][i + 1] = {(sum_dp[s][i].first + dp[s][i + 1].first) % MOD, (sum_dp[s][i].second + dp[s][i + 1].second) % MOD};
        }
    }

    int ans = 0;
    for (int lst = 1; lst <= n; lst++)
        ans = (ans * 1LL + 1LL * dp[n][lst].first + dp[n][lst].second) % MOD;
    cout << ans;



    return 0;
}
