#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

vector<vector<int> > gt;
vector<int> was;

vector<pair<int, int> > dp;

void dfs1(int v)
{
    was[v] = 1;
    dp[v] = {1, 0};
    for (auto u : gt[v])
    {
        if (was[u] == 0)
        {
            dfs1(u);
            dp[v].first += dp[u].second;
            dp[v].second += max(dp[u].first, dp[u].second);
        }
    }
}

int main()
{
    int n;
    cin >> n;
    vector<int> a(n);
    gt.resize(n);
    was.resize(n);
    dp.resize(n);
    int ans = 0;
    for (auto &i : a)
    {
        cin >> i;
        if (i != -1)
            i--;
    }
    for (int i = 0; i < n; i++)
    {
        if (a[i] != -1)
            gt[a[i]].push_back(i);
    }

    for (int i = 0; i < n; i++)
    {
        if (was[i] == 0)
        {
            dfs1(i);
            ans += max(dp[i].first, dp[i].second);
        }
    }
    cout << ans;


    return 0;
}
