#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>

using namespace std;

bool isSq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 5);
    for (int i = y; i < y + 10; i++)
        if (i * i == x)
            return true;
    return false;
}

int main()
{
    long long k;
    cin >> k;
    if (isSq(k))
        cout << k;
    else
    {
        long long start_p = 0;
        if (k > 0)
            start_p = sqrt(max(0LL, k - 5));
        for (long long i = start_p; i < start_p + 1e6; i++)
        {
            if (i * i - k >= 0 && isSq(i * i - k))
            {
                cout << i;
                return 0;
            }
        }
        cout << "none";
    }

    return 0;
}
