#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

#define int long long

using namespace std;

bool isSq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 5);
    for (long long i = y; i < y + 10; i++)
        if (i * i == x)
            return true;
    return false;
}

long long get_sq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 5);
    for (long long i = y; i < y + 10; i++)
        if (i * i == x)
            return i;
}

signed main()
{
    long long k;
    cin >> k;
    for (long long i = 0; i <= 1e8; i++)
    {
        if (isSq(k + i * i))
        {
            cout << get_sq(k + i * i);
            return 0;
        }
    }
    cout << "none";

    return 0;
}
