#include <iostream>
#include <vector>
#include <algorithm>
#include <set>
#include <map>
#include <cmath>

using namespace std;

bool isSq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return true;
    return false;
}

long long get_sq(long long x)
{
    long long y = sqrt(x);
    y = max(0LL, y - 2);
    for (long long i = y; i < y + 4; i++)
        if (i * i == x)
            return i;
}

signed main()
{
    long long k;
    cin >> k;
    if (k >= 0 && isSq(k))
    {
        cout << get_sq(k);
        return 0;
    }
    long long st = 0;
    if (k < 0)
        st = max(0LL, (long long int)sqrt(-k) - 3);
    for (long long i = 0; i <= 1e7; i++)
    {
        if (isSq(k + i * i))
        {
            cout << get_sq(k + i * i);
            return 0;
        }
    }
    cout << "none";

    return 0;
}
